image: node:12.19.0

workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: '$CI_COMMIT_BRANCH =~ /^develop(ment)?$/'
    - if: '$CI_COMMIT_BRANCH =~ /(master|main)/'
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG

cache: &global_cache
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .yarn/
    - node_modules/

stages:
  - install
  - test

install:
  stage: install
  script:
    - yarn install
  cache:
    <<: *global_cache

lint:
  stage: test
  dependencies:
    - install
  rules:
    - if: '$CI_COMMIT_BRANCH !~ /^renovate\//'
  script:
    - yarn # In case the cache failed
    - yarn lint
  artifacts:
    reports:
      codequality: gl-codequality.json
  cache:
    <<: *global_cache
    policy: pull

test_mysql:
  stage: test
  dependencies:
    - install
  services:
    - mysql:8.0.21
  variables:
    MYSQL_HOST: "mysql" # Should match the mysql service name/alias
    MYSQL_ROOT_PASSWORD: "test-ci"
    MYSQL_DATABASE: "test-ci"
  script:
    - yarn # In case the cache failed
    - yarn run test --detectOpenHandles
  cache:
    <<: *global_cache
    policy: pull

test_postgres:
  stage: test
  dependencies:
    - install
  services:
    - postgres:13-alpine
  variables:
    POSTGRES_HOST: "postgres" # Should match the mysql service name/alias
    POSTGRES_DB: "test-ci"
    POSTGRES_USER: "test-ci"
    POSTGRES_PASSWORD: "test-ci"
  script:
    - yarn # In case the cache failed
    - yarn run test --detectOpenHandles
  cache:
    <<: *global_cache
    policy: pull

include:
  - template: SAST.gitlab-ci.yml
  - template: Security/License-Scanning.gitlab-ci.yml
